//date 2015/09/24 yokomizo
//ピン番号マクロ定義
#define clk_pin 0
#define lat_pin 1
#define r1_pin 2
#define g1_pin 3
#define b1_pin 4
#define r2_pin 5
#define g2_pin 6
#define b2_pin 7
#define oeb_pin 8
#define a_pin 9
#define b_pin 10
#define c_pin 11
//表パタンデータ
unsigned short led_mem[512] ;

void setup() { 
  int x,y;
  pinMode(clk_pin, OUTPUT);     
  pinMode(lat_pin, OUTPUT);     
  pinMode(r1_pin, OUTPUT);      
  pinMode(g1_pin, OUTPUT);      
  pinMode(b1_pin, OUTPUT);        
  pinMode(r2_pin, OUTPUT);      
  pinMode(g2_pin, OUTPUT);      
  pinMode(b2_pin, OUTPUT);     
  pinMode(oeb_pin, OUTPUT);     
  pinMode(a_pin, OUTPUT);     
  pinMode(b_pin, OUTPUT);     
  pinMode(c_pin, OUTPUT); 
  //表示パターン初期値
  for(y=0;y<16;y++){
    for(x=0;x<16;x++)
      led_mem[(y<<5) +x] = (y<<8) + x ; 
    for(x=0;x<16;x++)
      led_mem[(y<<5) +x +16] =(y<<8) + (x<<4) ; 
  }
} 

void loop() { 
  int line_cnt;
  int line;
  int rgb_cnt;
  int bl_cnt;
  int bl_cnt_hold;
  int clk_cnt;
  char r1,g1,b1,r2,g2,b2;
  char sel_a,sel_b,sel_c;
  int line_adr;
  int led_data;
  int d_max_arry[5]={0,40,160,640,2560};
  while(1){
    for(line_cnt=0;line_cnt<8;line_cnt++){
        for(bl_cnt=0;bl_cnt<4;bl_cnt++) {  
          //シリアルデータ
          for(clk_cnt=0;clk_cnt<32;clk_cnt++){
            digitalWrite(clk_pin, LOW);
            line_adr =line_cnt*32;
            led_data=led_mem[line_adr+clk_cnt];
            digitalWrite(r1_pin,0x1&(led_data>>(bl_cnt)));
            digitalWrite(g1_pin,0x1&(led_data>>(bl_cnt+4)));
            digitalWrite(b1_pin,0x1&(led_data>>(bl_cnt+8)));
            line_adr =(line_cnt+8)*32;
            led_data=led_mem[(line_adr)+clk_cnt];
            digitalWrite(r2_pin,0x1&(led_data>>(bl_cnt)));
            digitalWrite(g2_pin,0x1&(led_data>>(bl_cnt+4)));
            digitalWrite(b2_pin,0x1&(led_data>>(bl_cnt+8)));
            //32CLK目でロード
            if(clk_cnt==31){
              digitalWrite(lat_pin, HIGH); 
            }
            //1CLK目でラッチ
            else{
              digitalWrite(lat_pin, LOW); 
            }
            //28CLK目で出力イネーブル
            if (clk_cnt==27){
              digitalWrite(oeb_pin, LOW); 
            }
            //31CLK目で出力ディセーブル
            else if(clk_cnt==30){
              digitalWrite(oeb_pin, HIGH); 
            }
            //30CLK目で遅延挿入
            if(clk_cnt==29){
              delayMicroseconds(d_max_arry[(int)bl_cnt_hold]);
            bl_cnt_hold = bl_cnt;
            }
            //クロックの立ち上がり
            digitalWrite(clk_pin, HIGH);
          } 
          digitalWrite(a_pin, 0x1&(line_cnt));  
          digitalWrite(b_pin, 0x1&(line_cnt>>1));  
          digitalWrite(c_pin, 0x1&(line_cnt>>2));
        }
      }
    }
  }
